=== debian/changelog ===
vtk-dicom (0.8.17-2) unstable; urgency=medium

  * Team upload.
  * d/patches: Fix bug in parsing multi-value SpecificCharacterSet

 -- Mathieu Malaterre <malat@debian.org>  Wed, 29 Oct 2025 14:41:17 +0100

vtk-dicom (0.8.17-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
    Closes: #1091516, #1063195
  * Finally fix name of the module
  * Standards-Version: 4.7.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Do not parse d/changelog (routine-update)
  * Build-Depends: s/dh-python/dh-sequence-python3/ (routine-update)
  * Use secure URI in Homepage field.
  * Rely on pre-initialized dpkg-architecture variables.
  * Avoid explicitly specifying -Wl,--as-needed linker flag.
  * watch file standard 4 (routine-update)
  * Make sure dh_missing --fail-missing works
  * Update lintian-overrides
  * d/copyright: review

 -- Andreas Tille <tille@debian.org>  Sat, 15 Feb 2025 17:13:30 +0100
